// JL20170204: TO BE REVISED
// Interface_TetGen.h
// Interface of DarcyLite+/FemLiteC++ with TetGen
// NOTE: The default configuration file ("TetgenConfig.txt") for TetGen
// must be in the project executable directory
// James Liu, Graham Harper, ColoState; 2007/01--2017/02

#include "TetraMesh.h"


// Getting a piecewise linear complex filename (.poly) from "TetgenConfig.txt",
// which will be used by TetGen

char* Get_PolyFileName_TetGen();


// Getting TetGen switches from the default config file "TetgenConfig.txt"

char* Get_SwitchString_TetGen();


// Generating a tetrahedral mesh (actually filling mesh info) by calling TetGen
// TetGen poly filename and swtches are provided by the above two functions

int Gen_TetraMesh_TetGen(TetraMesh &mesh);

// Interface_TetGen.h